<?php
/****************************************************************************\
* TaskFreak!                                                                 *
* single user                                                                *
******************************************************************************
* Version: 0.5                                                               *
* Release date: 2 january 2006                                               *
* Authors: Stan Ozier <stan@tirzen.net>                                      *
* License:  http://www.gnu.org/licenses/gpl.txt (GPL)                        *
******************************************************************************
* This file is part of "TaskFreak! single user" program.                     *
*                                                                            *
* TaskFreak! single user is free software; you can redistribute it and/or    *
* modify it under the terms of the GNU General Public License as published   *
* by the Free Software Foundation; either version 2 of the License, or (at   *  
* your option) any later version.                                            *
*                                                                            *
* TaskFreak! single user is distributed in the hope that it will be          *
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
* GNU General Public License for more details.                               *
*                                                                            *
* You should have received a copy of the GNU General Public License          *
* along with this program; if not, write to the Free Software                *
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA *
\****************************************************************************/


define('PRJ_DTE_NOW',strtotime(gmdate('Y-m-d',time()+Tzn::_getUserTZ())));

class Task extends TznDb
{
	function Task()
	{
		parent::TznDb('task');
		$this->addProperties(array(
			'id'	 			=> 'UID',
			'priority'			=> 'NUM',
			'project'			=> 'STR',
			'context'			=> 'STR',
			'title'				=> 'STR',
			'description'		=> 'BBS',
			'status'			=> 'NUM',
			'creationDate'		=> 'DTM',
			'lastChangeDate'	=> 'DTM',
			'deadlineDate'		=> 'DTE'
		));
	}
	
	function pDeadline() {
		if (ereg('(9999|0000)',$this->deadlineDate)) {
			echo '-';
		} else {
			$dead = strtotime($this->deadlineDate);
			$diff = $dead - intval(PRJ_DTE_NOW) ;
			if ($diff < 0) {
				if ($this->status < 5) {
					echo '<span class="dlate">';
					$this->pDte('deadlineDate','SHT');
					echo '</span>';
				} else {
					echo '<span class="ddone">';
					$this->pDte('deadlineDate','SHT');
					echo '</span>';
				}
			} else if ($diff == 0) {
				echo '<span class="dday">'.$GLOBALS['arrLanguageDate']['today'].'</span>';
			} else {
				$diff = $diff / 3600 / 24;
				if (@constant('FRK_DATEDIFF_MODE') =='day') {
					if (@constant('FRK_DATEDIFF_TOMORROW') && $diff == 1) {
						echo $GLOBALS['arrLanguageDate']['tomorrow'];
					} else if ($diff < 7) {
					   $day = strtolower(date('l',$dead));
					   if (array_key_exists($day,$GLOBALS['arrLanguageDateDay'])) {
					       $day = $GLOBALS['arrLanguageDateDay'][$day];
					   }
					   echo '<span class="small">'.ucFirst($day).'</span>';
					} else {
						echo '<span class="small">'
							.$this->getDte('deadlineDate','SHT','')
							.'</span>';
					}
				} else {
					switch($diff) {
						case '1':
							if (@constant('FRK_DATEDIFF_TOMORROW')) {
								echo $GLOBALS['arrLanguageDate']['tomorrow'];
							} else {
								echo '1 '.$GLOBALS['arrLanguageDate']['day'];
							}
							break;
						case '2':
						case '3':
						case '4':
						case '5':
						case '6':
							echo $diff.' '.$GLOBALS['arrLanguageDate']['day'].'s';
							break;
						default:
							echo '<span class="small">'
								.$this->getDte('deadlineDate','SHT','')
								.'</span>';
							break;
					}
				}
			}
		}
	}

	function check() {
		$this->checkEmpty('title');
		if (!$this->priority) {
			$this->priority = 4;
		}
		if (!$this->deadlineDate) {
			$this->deadlineDate = '9999-00-00';
		}
		return (count($this->_error) == 0);
	}
	
	function add() {
        $this->setDtm('creationDate','NOW');
        $this->setDtm('lastChangeDate','NOW');
        return parent::add();
    }
	
	function update($fields=null) {
        $this->setDtm('lastChangeDate','NOW');
        if ($fields && (!ereg('lastChangeDate',$fields))) {
        	$fields .= ",lastChangeDate";
        }
        return parent::update($fields);
    }
	
	function loadList($limit=NULL) {
		$sql = 'SELECT * FROM '.$this->gTable();
		return parent::loadList($sql,$limit);
	}

	function getDir($pDir, $key='') {
		$fDir = ($key == 'deadline')?-$pDir:$pDir;
		if ($pDir == 1) {
			return 'ASC';
		} else {
			return 'DESC';
		}
	}

	function setOrder($pSort,$pDir) {
		switch($pSort) {
			case 'deadline';
				$this->addOrder('deadlineDate '.$this->getDir($pDir,'deadline')
					.', priority '.$this->getDir($pDir));
				break;
			case 'priority':
				$this->addOrder('priority '.$this->getDir($pDir)
					.', deadlineDate '.$this->getDir($pDir,'deadline'));
				break;
			default:
				$this->addOrder($pSort.' '.$this->getDir($pDir)
					.', deadlineDate ASC, priority ASC');
				break;
		}
	}
}

class Project extends TznDb {

	function Project() {
		parent::TznDb('task');
		$this->addProperties(array(
			'project'			=> 'STR',
			'taskCount'		=> 'NUM'
		));
	}

	function loadList() {
		$this->addGroup('project');
    	$this->addOrder('project');
    	$sql = 'SELECT project, count(taskId) as taskCount FROM '.$this->gTable();
		return parent::loadList($sql);
    }

}

?>
